
# 
#   ______                           __        ____    _      __  __     
#  / ___(_)__ ___ _  ___  ___ ____  / /__     / __/___(_)_ __/ /_/ /____ 
# / (_ / / _ `/  ' \/ _ \/ _ `/ _ \/ / _ \   _\ \/ __/ / // / __/ __/ _ \
# \___/_/\_,_/_/_/_/ .__/\_,_/\___/_/\___/  /___/\__/_/\_,_/\__/\__/\___/
#                 /_/                                                   
# http://www.giampaolo-sciutto.it/

# Name Script : 
# Descrizione : 
# 
# Versione    : 1.0
# Requisiti   : 
# Piattaforme Verificate :
#
# Modify by Giampaolo Sciutto
# Date Modify: 25/11/2016
#


Import-Module MSOnline

######## Parameters START ###########
  
#Office 365 Admin Credentials
#To create Password File, run: 
# $Key = (3,4,2,3,56,34,254,222,1,1,2,23,42,54,33,233,1,34,2,7,6,5,35,43)
# Read-Host "enter password" -AsSecureString | ConvertFrom-SecureString -key $key| Out-File c:\scripts\password2.txt
$Key = (3,4,2,3,56,34,254,222,1,1,2,23,42,54,33,233,1,34,2,7,6,5,35,43)
$CloudUsername = 'adsync@DOMINIO.it'
$CloudPasswordFile = 'c:\scripts\password.txt'
$CloudCred = New-Object System.Management.Automation.PSCredential $CloudUsername,(Get-Content $CloudPasswordFile | ConvertTo-SecureString -key $key)
 
#Get-Content $CloudPasswordFile | out-file c:\scripts\testo3.txt

# To get AccountSkuId, run: Get-MsolAccountSku 
$LicenseSKUE3 = 'csipiemonte:ENTERPRISEPACK'

#To get service ID names run: (Get-MsolAccountSku | where {$_.AccountSkuId -eq '<AccountSkuId>'}).ServiceStatus
#SWAY = Sway 
#INTUNE_O365 = Mobile Device Management for Office 365 
#YAMMER_ENTERPRISE = Yammer 
#RMS_S_ENTERPRISE = Azure Rights Management (RMS) 
#OFFICESUBSCRIPTION = Office Professional Plus 
#MCOSTANDARD = Skype for Business Online 
#SHAREPOINTWAC = Office Online 
#SHAREPOINTENTERPRISE = SharePoint Online 
#EXCHANGE_S_ENTERPRISE = Exchange Online Plan 2 
$DisablePlans ="PROJECTWORKMANAGEMENT","SWAY","INTUNE_O365","EXCHANGE_S_ENTERPRISE"

#The AD Group MUST be Synced into AzureAD
$GroupE3 = 'O365_licenseE3'

######## Parameters END ###########

#Connect to Office 365 
Connect-MsolService -Credential $CloudCred
function Get-JDMsolGroupMember { 
    param(
        [CmdletBinding(SupportsShouldProcess=$true)]
        [Parameter(Mandatory=$true, ValueFromPipeline=$true,ValueFromPipelineByPropertyName=$true,Position=0)]
        [ValidateScript({Get-MsolGroup -ObjectId $_})]
        $ObjectId,
        [switch]$Recursive
    )
    begin {
        $MSOLAccountSku = Get-MsolAccountSku -ErrorAction Ignore -WarningAction Ignore
        if (-not($MSOLAccountSku)) {
            throw "Not connected to Azure AD, run Connect-MsolService"
        }
    } 
    process {
        $UserMembers = Get-MsolGroupMember -GroupObjectId $ObjectId -MemberObjectTypes User -All
        if ($PSBoundParameters['Recursive']) {
            $GroupsMembers = Get-MsolGroupMember -GroupObjectId $ObjectId -MemberObjectTypes Group -All
            $GroupsMembers | ForEach-Object -Process {
                $UserMembers += Get-JDMsolGroupMember -Recursive -ObjectId $_.ObjectId 
            }
        }
        Write-Output ($UserMembers | Sort-Object -Property EmailAddress -Unique) 
         
    }
    end {
     
    }
}

#Get-MsolUser -UserPrincipalName cmelone@costa.it | out-file c:\scripts\testo2.txt
  
$Licenses = @{                          
                 'E3' = @{ 
                          LicenseSKU = $LicenseSKUE3
                          Group = $GroupE3
			  LO = New-MsolLicenseOptions -AccountSkuId $LicenseSKUE3 -DisabledPlans $DisablePlans
                        }
            }
$UsageLocation = 'IT'


  
foreach ($license in $Licenses.Keys) {
  
    $GroupName = $Licenses[$license].Group
    $GroupID = (Get-MsolGroup -All | Where-Object {$_.DisplayName -eq $GroupName}).ObjectId
    $AccountSKU = Get-MsolAccountSku | Where-Object {$_.AccountSKUID -eq $Licenses[$license].LicenseSKU}
  
    Write-Output "Checking for unlicensed $license users in group $GroupName with ObjectGuid $GroupID..."
  
    $GroupMembers = (Get-JDMsolGroupMember -ObjectId $GroupID -Recursive | Where-Object {$_.IsLicensed -eq $false}).EmailAddress
  
    if ($AccountSKU.ActiveUnits - $AccountSKU.consumedunits -lt $GroupMembers.Count) { 
        Write-Warning 'Not enough licenses for all users, please remove user licenses or buy more licenses'
      }
         
        foreach ($User in $GroupMembers) {
          Try {
            Set-MsolUser -UserPrincipalName $User -UsageLocation $UsageLocation -ErrorAction Stop -WarningAction Stop
            Set-MsolUserLicense -UserPrincipalName $User -AddLicenses $AccountSKU.AccountSkuId -LicenseOptions $Licenses[$license].LO -ErrorAction Stop -WarningAction Stop
            Write-Output "Successfully licensed $User with $license"
          } catch {
            Write-Warning "Error when licensing $User`r`n$_"
          }
          
        }
  
}
